using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Data;
using ExamModel.Auto_Generated_Code;
//Դwww.51aspx.com(1)

namespace ExamDAL.Auto_Generated_Code
{
    public static class CourseService
    {
        //ӿĿ
        public static int AddCourse(Course course)
        {
            string sql = "insert into Course(DepartmentID,CourseName) values (@DepartmentID,@Coursename)";
            OleDbParameter[] para = new OleDbParameter[]
            {
                new OleDbParameter("@DepartmentID",course.DepartmentID.DepartmentID),//FK
                new OleDbParameter("@CourseName",course.CName)
            };
            return DBHelp.ExecuteCommand(sql, para);
        }

        //ܹIDŲѯĿ Course
        public static Course GetCourseById(int id)
        {
            string sql = "select * from Course where CourseID=@id";
            int departmentId;
            try
            {
                OleDbDataReader reader = DBHelp.GetReader(sql, new OleDbParameter("@id", id));
                if (reader.Read())
                {
                    Course course = new Course();
                    course.CID = (int)reader["CourseID"];
                    departmentId = (int)reader["DepartmentID"];//FK
                    course.CName = (string)reader["CourseName"];

                    reader.Close();
                    course.DepartmentID = DepartmentService.GetDepartmentById(departmentId);

                    return course;
                }
                else
                {
                    reader.Close();
                    return null;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
               
            }

        }
       
        //еĿĿ DataSet
        public static DataSet GetCourseList()
        {
            string sql = "select * from Course";
            return DBHelp.GetDataSet(sql);
        }
      
        //ѯпĿ
        public static IList<Course> GetAllCourses()
        {
            string sqlAll = "select * from Course";
            return GetCoursesBySql(sqlAll);
        }
        //SQLѯĿ
        private static IList<Course> GetCoursesBySql(string safeSql)
        {
            List<Course> list = new List<Course>();
            using (DataSet table = DBHelp.GetDataSet(safeSql))
            {
                foreach (DataRow row in table.Tables[0].Rows)
                {
                    Course course = new Course();
                    course.CID = (int)row["CourseID"];
                    course.CName = (string)row["CourseName"];
                    course.DepartmentID = DepartmentService.GetDepartmentById((int)row["DepartmentID"]);//FK
                    list.Add(course);
                }
                return list;

            }
        }
        //ͨĿƻÿĿID
        public static Course GetCourseByString(string str)
        {
            string sql = "select * from Course where CourseName=@courseName";

            int departmentId;//ϵID

            try
            {
                OleDbDataReader reader = DBHelp.GetReader(sql, new OleDbParameter("@courseName", str));
                if (reader.Read())
                {
                    Course course = new Course();

                    course.CID = (int)reader["CourseID"];
                    course.CName = str;
                    departmentId = (int)reader["DepartmentID"];//FK
                    reader.Close();

                    course.DepartmentID = DepartmentService.GetDepartmentById(departmentId);
                    return course;
                }
                else
                {
                    reader.Close();
                    return null;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }
        //¿Ŀ
        public static void ModifyCourse(Course course)
        {     
            try
            {
                string sql1 = "update Course set CourseName='" + course.CName + "' where CourseID=" + course.CID;
                DBHelp.ExecuteCommand(sql1);

            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }
        //ɾĿ
        public static void DeleteBookById(int id)
        {
            string sql = "Delete from Course where CourseID=" + id;
            try
            {
                DBHelp.ExecuteCommand(sql);
         
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }
    }
}
