using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using ExamModel.Auto_Generated_Code;

namespace ExamDAL.Auto_Generated_Code
{
    public class FillBlankProblemServices
    {
        //
        public static int AddFillBlankProblem(FillBlankProblem fillPro)
        {
            string sql = "insert into FillBlankProblem (CourseID,FrontTitle,BackTitle,Answer)" +
                       "values(@courseId,@frontTitle,@backTitle,@answer)";
            try
            {
                OleDbParameter[] pare = new OleDbParameter[]
                {
                    new OleDbParameter("@courseId",fillPro.FCourse.CID),//FK
                    new OleDbParameter("@frontTitle",fillPro.FfrontTitle),
                    new OleDbParameter("@backTitle",fillPro.FBackTitle),
                    new OleDbParameter("@answer",fillPro.Fanswer)
                };
                return DBHelp.ExecuteCommand(sql, pare);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        //
        public static bool UpdateFillBlankProblem(FillBlankProblem fillPro)
        {
            try
            {
                string sql1 = "update FillBlankProblem set CourseID=" + fillPro.FCourse.CID + ",FrontTitle='" + fillPro.FfrontTitle + "',BackTitle='" + fillPro.FBackTitle +  "',Answer='" + fillPro.Fanswer + "' where FillBlankProblemID=" + fillPro.FillBlankProblemID;
                DBHelp.ExecuteCommand(sql1);
                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        //ͨIDɾ
        public static bool DeleteFillBlankById(int fillProid)
        {
            try
            {
                string sql = "Delete from FillBlankProblem where FillBlankProblemID=" + fillProid;
                DBHelp.ExecuteCommand(sql);
                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        //ͨIDе
        public static DataTable GetAllFillBlankProblemId(string id)
        {
            string OleDb = "select FillBlankProblemID from FillBlankProblem where CourseID=" + id.ToString();
            DataSet ds = DBHelp.GetDataSet(OleDb);
            return ds.Tables[0];
        }
        //б
        public static IList<FillBlankProblem> GetFillBlankProblemByOleDb(string values, string id)
        {
            List<FillBlankProblem> list = new List<FillBlankProblem>();
            string oleDb = "select * from FillBlankProblem where FillBlankProblemID in (" + values + ") and CourseID=" + id;
            using (DataSet ds = DBHelp.GetDataSet(oleDb))
            {
                foreach (DataRow row in ds.Tables[0].Rows)
                {
                    FillBlankProblem fillBlankProblem = new FillBlankProblem();
                    fillBlankProblem.FillBlankProblemID = (int)row["FillBlankProblemID"];
                    fillBlankProblem.FCourse = CourseService.GetCourseById((int)row["CourseID"]);//
                    fillBlankProblem.FfrontTitle = (string)row["FrontTitle"];
                    fillBlankProblem.FBackTitle = (string)row["BackTitle"];
                    fillBlankProblem.Fanswer = (string)row["Answer"];
                    list.Add(fillBlankProblem);
                }
                return list;
            }
        }

        //ͨĿѯĿ
        public static DataSet GetFillBlankByCourseName(Course course)
        {
            string sql = "select * from FillBlankProblem where CourseID=" + course.CID;
            return DBHelp.GetDataSet(sql);

        }
        //ͨIDÿĿ
        public static FillBlankProblem GetFillBlankproblemById(int fillId)
        {
            string sql = "select * from FillBlankProblem where FillBlankProblemID=" + fillId;

            int courseId;
            try
            {
                OleDbDataReader reader = DBHelp.GetReader(sql);
                if (reader.Read())
                {
                    FillBlankProblem fillPro = new FillBlankProblem();
                    fillPro.FillBlankProblemID = (int)reader["FillBlankProblemID"];
                    fillPro.FfrontTitle = (string)reader["FrontTitle"];
                    fillPro.FBackTitle = (string)reader["BackTitle"];
                    fillPro.Fanswer = (string)reader["Answer"];
                    courseId = (int)reader["CourseID"];//FK
                    reader.Close();

                    fillPro.FCourse = CourseService.GetCourseById(courseId);
                    return fillPro;

                }
                else
                {
                    reader.Close();
                    return null;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }
    }
}
