﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Collections;
using ExamModel.Auto_Generated_Code;
using ExamDAL.Auto_Generated_Code;

namespace ExamDAL.Auto_Generated_Code
{
    public static class MakePaperService
    {
        /// <summary>
        /// 获取单选的题目
        /// </summary>
        /// <param name="sNum"></param>
        /// <param name="courseID"></param>
        /// <returns></returns>
        public static IList<SingleProblem> GetSingleProblesByRang(string sNum, string courseID)
        {

            string param = String.Empty;
            Random myRan = new Random();
            Hashtable hashtable = new Hashtable();
            int num = Int16.Parse(sNum.ToString());
            DataTable table = SingleProblemService.GetAllSingleProblemId(courseID);
            //if (table.Rows.Count < 0)
            //{
            //    break;
            //}

            int count = table.Rows.Count;
            for (int i = 0; hashtable.Count < num; i++)
            {
                int temp = myRan.Next(0, count);
                if (!hashtable.ContainsValue(temp))
                {
                    hashtable.Add(temp,temp);
                    string s = table.Rows[temp][0].ToString();
                    param = param + s + ",";
                }
            }
            if (param.Length > 0)
            {
                param = param.Substring(0, param.Length - 1);
            }
            return SingleProblemService.GetSingleProblemByOleDb(param, courseID);
        }
        /// <summary>
        /// 获取多选的题目
        /// </summary>
        /// <param name="sNum"></param>
        /// <param name="courseID"></param>
        /// <returns></returns>
        public static IList<MultiProblem> GetMultiProblesByRang(string sNum, string courseID)
        {

            string param = String.Empty;
            Random myRan = new Random();
            Hashtable hashtable = new Hashtable();
            int num = Int16.Parse(sNum.ToString());
            DataTable table =MultiProblemServices.GetAllMultiProblemId(courseID);
            int count = table.Rows.Count;
            for (int i = 0; hashtable.Count < num; i++)
            {
                int temp = myRan.Next(0, count);
                if (!hashtable.ContainsValue(temp))
                {
                    hashtable.Add(temp, temp);
                    string s = table.Rows[temp][0].ToString();
                    param = param + s + ",";
                }
            }
            if (param.Length > 0)
            {
                param = param.Substring(0, param.Length - 1);
            }
            return MultiProblemServices.GetMultiProblemByOleDb(param, courseID);
        }
        /// <summary>
        /// 获得判断题的题目
        /// </summary>
        /// <param name="sNum"></param>
        /// <param name="courseID"></param>
        /// <returns></returns>
        public static IList<JudgeProblem> GetJudgeProblesByRang(string sNum, string courseID)
        {

            string param = String.Empty;
            Random myRan = new Random();
            Hashtable hashtable = new Hashtable();
            int num = Int16.Parse(sNum.ToString());
            DataTable table = JudgeProblemServices.GetAllJudgeProblemId(courseID);
            int count = table.Rows.Count;
            for (int i = 0; hashtable.Count < num; i++)
            {
                int temp = myRan.Next(0, count);
                if (!hashtable.ContainsValue(temp))
                {
                    hashtable.Add(temp, temp);
                    string s = table.Rows[temp][0].ToString();
                    param = param + s + ",";
                }
            }
            if (param.Length > 0)
            {
                param = param.Substring(0, param.Length - 1);
            }
            return JudgeProblemServices.GetJudgeProblemByOleDb(param, courseID);
        }

        /// <summary>
        /// 获得填空的题目
        /// </summary>
        /// <param name="sNum"></param>
        /// <param name="courseID"></param>
        /// <returns></returns>
        public static IList<FillBlankProblem> GetFillBlankProblesByRang(string sNum, string courseID)
        {

            string param = String.Empty;
            Random myRan = new Random();
            Hashtable hashtable = new Hashtable();
            int num = Int16.Parse(sNum.ToString());
            DataTable table = FillBlankProblemServices.GetAllFillBlankProblemId(courseID);
            int count = table.Rows.Count;
            for (int i = 0; hashtable.Count < num; i++)
            {
                int temp = myRan.Next(0, count);
                if (!hashtable.ContainsValue(temp))
                {
                    hashtable.Add(temp, temp);
                    string s = table.Rows[temp][0].ToString();
                    param = param + s + ",";
                }
            }
            if (param.Length > 0)
            {
                param = param.Substring(0, param.Length - 1);
            }
            return FillBlankProblemServices.GetFillBlankProblemByOleDb(param, courseID);
        }

        /// <summary>
        ///获得简答题的题目 
        /// </summary>
        /// <param name="sNum"></param>
        /// <param name="courseID"></param>
        /// <returns></returns>
        public static IList<Jianda> GetJiandaProblesByRang(string sNum, string courseID)
        {

            string param = String.Empty;
            Random myRan = new Random();
            Hashtable hashtable = new Hashtable();
            int num = Int16.Parse(sNum.ToString());
            DataTable table =JiandaServices.GetAllJiandaProblemId(courseID);
            int count = table.Rows.Count;
            for (int i = 0; hashtable.Count < num; i++)
            {
                int temp = myRan.Next(0, count);
                if (!hashtable.ContainsValue(temp))
                {
                    hashtable.Add(temp, temp);
                    string s = table.Rows[temp][0].ToString();
                    param = param + s + ",";
                }
            }
            if (param.Length > 0)
            {
                param = param.Substring(0, param.Length - 1);
            }
            return JiandaServices.GetJudgeProblemByOleDb(param, courseID);
        }




    }
}
