using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.OleDb;
using ExamModel.Auto_Generated_Code;

namespace ExamDAL.Auto_Generated_Code
{
    public class MultiProblemServices
    {
        //ӵѡ
        public static int AddMultiProblem(MultiProblem multiPro)
        {
            string sql = "insert into MultiProblem (CourseID,Title,AnswerA,AnswerB,AnswerC,AnswerD,Answer)" +
                       "values(@courseId,@title,@answerA,@answerB,@answerC,@answerD,@answer)";
            try
            {
                OleDbParameter[] pare = new OleDbParameter[]
                {
                    new OleDbParameter("@courseId",multiPro.MCourse.CID),//FK
                    new OleDbParameter("@title",multiPro.MTitle),
                    new OleDbParameter("@answerA",multiPro.ManswerA),
                    new OleDbParameter("@answerB",multiPro.ManswerB),
                    new OleDbParameter("@answerC",multiPro.ManswerC),
                    new OleDbParameter("@answerD",multiPro.ManswerD),
                    new OleDbParameter("@answer",multiPro.Manswer)
                };
                return DBHelp.ExecuteCommand(sql, pare);
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        //µѡ
        public static bool UpdateMultiProblem(MultiProblem multiPro)
        {
            try
            {
                string sql1 = "update MultiProblem set CourseID=" + multiPro.MCourse.CID + ",Title='" + multiPro.MTitle + "',AnswerA='" + multiPro.ManswerA + "',AnswerB='" + multiPro.ManswerB + "',AnswerC='" + multiPro.ManswerC + "',AnswerD='" + multiPro.ManswerD + "',Answer='" + multiPro.Manswer + "' where MultiProblemID=" + multiPro.MultiProblemID;
                DBHelp.ExecuteCommand(sql1);
                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        //ͨIDжѡ
        public static DataTable GetAllMultiProblemId(string id)
        {
            string OleDb = "select MultiProblemID from MultiProblem where CourseID=" + id.ToString();
            DataSet ds = DBHelp.GetDataSet(OleDb);
            return ds.Tables[0];
        }

        //ͨIDɾ
        public static bool DeleteMultiById(int multiProid)
        {
            try
            {
                string sql = "Delete from MultiProblem where MultiProblemID=" + multiProid;
                DBHelp.ExecuteCommand(sql);
                return true;
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }

        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="values"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public static IList<MultiProblem> GetMultiProblemByOleDb(string values, string id)
        {
            List<MultiProblem> list = new List<MultiProblem>();
            string oleDb = "select * from MultiProblem where MultiProblemID in (" + values + ") and CourseID=" + id;
            using (DataSet ds = DBHelp.GetDataSet(oleDb))
            {
                foreach (DataRow row in ds.Tables[0].Rows)
                {
                    MultiProblem multiProblem = new MultiProblem();
                    multiProblem.MultiProblemID = (int)row["MultiProblemID"];
                    multiProblem.MCourse = CourseService.GetCourseById((int)row["CourseID"]);//
                    multiProblem.MTitle = (string)row["Title"];
                    multiProblem.ManswerA = (string)row["AnswerA"];
                    multiProblem.ManswerB = (string)row["AnswerB"];
                    multiProblem.ManswerC = (string)row["AnswerC"];
                    multiProblem.ManswerD = (string)row["AnswerD"];
                    multiProblem.Manswer = (string)row["Answer"];
                    list.Add(multiProblem);
                }
                return list;
            }
        }
        //ͨIDÿĿ
        public static MultiProblem GetMultiproblemById(int multiId)
        {
            string sql = "select * from MultiProblem where MultiProblemID=" + multiId;

            int courseId;
            try
            {
                OleDbDataReader reader = DBHelp.GetReader(sql);
                if (reader.Read())
                {
                    MultiProblem multiPro = new MultiProblem();
                    multiPro.MultiProblemID = (int)reader["MultiProblemID"];
                    multiPro.MTitle = (string)reader["Title"];
                    multiPro.ManswerA = (string)reader["AnswerA"];
                    multiPro.ManswerB = (string)reader["AnswerB"];
                    multiPro.ManswerC = (string)reader["AnswerC"];
                    multiPro.ManswerD = (string)reader["AnswerD"];
                    multiPro.Manswer = (string)reader["Answer"];
                    courseId = (int)reader["CourseID"];//FK
                    reader.Close();
                    multiPro.MCourse = CourseService.GetCourseById(courseId);
                    return multiPro;
                }
                else
                {
                    reader.Close();
                    return null;
                }
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
        }


        //ͨĿѯѡĿ
        public static DataSet GetMultiproByCourseName(Course course)
        {
            string sql = "select * from MultiProblem where CourseID=" + course.CID;
            return DBHelp.GetDataSet(sql);

        }
    }
}
