﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Data;
using ExamModel.Auto_Generated_Code;

namespace ExamDAL.Auto_Generated_Code
{
    public static class PaperDetailService
    {
        /// <summary>
        /// 添加试卷的详细信息
        /// </summary>
        /// <param name="paperDetail"></param>
        /// <returns>受影响的行数</returns>
        public static int AddPaperDetail(PaperDetail paperDetail)
        {
            string oleDbString = "insert into PaperDetail(PaperID,Type,TitleID,Mark)" + "values(@PaperID,@Type,@Title,@Mark)";
            OleDbParameter[] para = new OleDbParameter[] 
            {
                new OleDbParameter("@PaperID",paperDetail.PaperID.PaperId),
                new OleDbParameter("@Type",paperDetail.Type),
                new OleDbParameter("@Title",paperDetail.TitleID),
                new OleDbParameter("@Mark",paperDetail.Mark)
               
            };
            return DBHelp.ExecuteCommand(oleDbString,para);
        }
        //返回DataSet
        public static DataSet GetAllPaperDetailbyId(int id, string type)
        {
            string oleDbString=null;
            if (type == "单选题")
            {
                 oleDbString= "SELECT SingleProblem.Title, SingleProblem.AnswerA, SingleProblem.AnswerB, SingleProblem.AnswerC, SingleProblem.AnswerD, SingleProblem.Answer, PaperDetail.Mark, PaperDetail.PaperID, PaperDetail.Type FROM SingleProblem INNER JOIN PaperDetail ON SingleProblem.SingleProblemID = PaperDetail.TitleID WHERE (((PaperDetail.PaperID)=" + id + ") AND ((PaperDetail.Type)='" + type + "'))";
            }
            else if (type == "多选题")
            {
                oleDbString = "SELECT MultiProblem.Title, MultiProblem.AnswerA, MultiProblem.AnswerB, MultiProblem.AnswerC, MultiProblem.AnswerD, MultiProblem.Answer, PaperDetail.Mark, PaperDetail.PaperID, PaperDetail.Type FROM MultiProblem INNER JOIN PaperDetail ON MultiProblem.MultiProblemID = PaperDetail.TitleID WHERE (((PaperDetail.PaperID)=" + id + ") AND ((PaperDetail.Type)='" + type + "'))";
            }
            else if (type == "判断题")
            {
                oleDbString = "SELECT JudgeProblem.Title, JudgeProblem.Answer, PaperDetail.Mark, PaperDetail.PaperID, PaperDetail.Type FROM JudgeProblem INNER JOIN PaperDetail ON JudgeProblem.JudgeProblemID = PaperDetail.TitleID WHERE (((PaperDetail.PaperID)=" + id + ") AND ((PaperDetail.Type)='" + type + "'))";
            }
            else if (type == "填空题")
            {
                oleDbString = "SELECT FillBlankProblem.FrontTitle, FillBlankProblem.BackTitle, FillBlankProblem.Answer, PaperDetail.Mark, PaperDetail.PaperID, PaperDetail.Type FROM FillBlankProblem INNER JOIN PaperDetail ON FillBlankProblem.FillBlankProblemID = PaperDetail.TitleID WHERE (((PaperDetail.PaperID)=" + id + ") AND ((PaperDetail.Type)='" + type + "'))";
            }
            else if (type == "简答题")
            {
                oleDbString = "SELECT Jianda.Title, Jianda.Answer, PaperDetail.Mark, PaperDetail.PaperID, PaperDetail.Type FROM Jianda INNER JOIN PaperDetail ON Jianda.JiandaID = PaperDetail.TitleID WHERE (((PaperDetail.PaperID)=" + id + ") AND ((PaperDetail.Type)='" + type + "'))";
            }
            DataSet dataset = DBHelp.GetDataSet(oleDbString); 
            return dataset;
        }
        //返回对象
        public static PaperDetail GetPaperDetailById(int id, string type)
        {
            string sql = "select * from PaperDetail where PaperId=" + id + "AND Type='" + type + "'";
            try
            {
                PaperDetail pd = new PaperDetail();
                DataSet ds = DBHelp.GetDataSet(sql);
                foreach (DataRow row in ds.Tables[0].Rows)
                {

                    pd.Mark = (int)row["Mark"];
                    break;
                }
                return pd;

            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                throw e;
            }
       
        }
    }
}
