﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Data;
using ExamModel.Auto_Generated_Code;

namespace ExamDAL.Auto_Generated_Code
{
     public static class PaperService
    {
         public static int AddPaper(Paper paper)
         {
             string oleDbString = "insert into Paper(CourseID,PaperName,LimitTime,PaperState) values (@CourseID,@PaperName,@LimitTime,@PaperState)";
             OleDbParameter[] para = new OleDbParameter[] 
             {
                 new OleDbParameter("@CourseID",paper.CourseId.CID),
                 new OleDbParameter("@PaperName",paper.PaperName),
                 new OleDbParameter("@LimitTime",paper.LimitTime),
                 new OleDbParameter("@PaperState",paper.PaperState)
             }; 
             return DBHelp.ExecuteCommand(oleDbString,para);
         }

         //public static void  AddPaper(Paper paper)
         //{
         //    string oleDbString = "insert into Paper(CourseID,PaperName,LimitTime,PaperState) values (@CourseID,@PaperName,@LimitTime,@PaperState)";
         //    OleDbParameter[] para = new OleDbParameter[] 
         //    {
         //        new OleDbParameter("@CourseID",paper.CourseId.CID),
         //        new OleDbParameter("@PaperName",paper.PaperName),
         //        new OleDbParameter("@LimitTime",paper.LimitTime),
         //        new OleDbParameter("@PaperState",paper.PaperState)
         //    };
         //    int i=DBHelp.ExecuteCommand(oleDbString);
         //}

         public static DataTable GetAllPaper()
         {
             
             string oleDb = "select * from Paper";
             DataSet ds = DBHelp.GetDataSet(oleDb);
             return ds.Tables[0];
         }

         public static IList<Paper> GetAllPapers()
         {
             List<Paper> list = new List<Paper>();
             string oleDbString = "select * from Paper";
             using (DataSet ds = DBHelp.GetDataSet(oleDbString))
             {
                 foreach (DataRow row in ds.Tables[0].Rows)
                 {
                     Paper paper = new Paper();
                     paper.PaperId = (int)row["PaperID"];
                     paper.CourseId = CourseService.GetCourseById((int)row["CourseID"]);//
                     paper.PaperName = (string)row["PaperName"];
                     paper.LimitTime = (int)row["LimitTime"];
                     paper.PaperState = (bool)row["PaperState"];
                     list.Add(paper);
                 }
                 return list;
             }
         }
         //获得试卷
         public static Paper GetPaperById(int id)
         {
             string sql = "select * from Paper where PaperID=@id";
             int courseId;
             try
             {
                 OleDbDataReader reader = DBHelp.GetReader(sql, new OleDbParameter("@id", id));
                 if (reader.Read())
                 {
                     Paper paper = new Paper();
                     paper.PaperId = (int)reader["PaperID"];
                     courseId = (int)reader["CourseID"];//FK
                     paper.PaperName = (string)reader["PaperName"];
                     paper.LimitTime = (int)reader["LimitTime"];
                     paper.PaperState = (bool)reader["PaperState"];
                     reader.Close();
                     paper.CourseId = CourseService.GetCourseById(courseId);

                     return paper;
                 }
                 else
                 {
                     reader.Close();
                     return null;
                 }
             }
             catch (Exception e)
             {
                 Console.WriteLine(e.Message);
                 throw e;

             }
         }
         //通过名字获得试卷
         public static Paper GetPaperByName(string Name)
         {
             string sql = "select * from Paper where PaperName=@Name";
             int courseId;
             try
             {
                 OleDbDataReader reader = DBHelp.GetReader(sql, new OleDbParameter("@Name", Name));
                 if (reader.Read())
                 {
                     Paper paper = new Paper();
                     paper.PaperId = (int)reader["PaperID"];
                     courseId = (int)reader["CourseID"];//FK
                     paper.PaperName = (string)reader["PaperName"];
                     paper.LimitTime = (int)reader["LimitTime"];
                     paper.PaperState = (bool)reader["PaperState"];
                     reader.Close();
                     paper.CourseId = CourseService.GetCourseById(courseId);

                     return paper;
                 }
                 else
                 {
                     reader.Close();
                     return null;
                 }
             }
             catch (Exception e)
             {
                 Console.WriteLine(e.Message);
                 throw e;

             }


         }

         public static void ModifyPaper(Paper paper)
         {
             String oleDbString = "update Paper set CourseID="+paper.CourseId.CID+",PaperName= '"+paper.PaperName.ToString()+" ',LimitTime="+paper.LimitTime+",PaperState="+paper.PaperState+" where PaperID="+paper.PaperId;
            
             DBHelp.ExecuteCommand(oleDbString);
         }

         public static void DeletePaper(Paper paper)
         {
             DeletePaperById(paper.PaperId);
         }

         public static void DeletePaperById(int id)
         {
             try
             {
                 string oleDbString = "Delete * from Paper where PaperID=" + id;
                 string delPaperDetail = "Delete * from PaperDetail where PaperID=" + id;
                 DBHelp.ExecuteCommand(oleDbString);
                 DBHelp.ExecuteCommand(delPaperDetail);
             }
             catch (Exception e)
             {
                 Console.WriteLine(e.Message);
                 throw e;
             }
         }
         //获得所有可用试卷
         public static DataSet GetUsePaper(bool b)
         {
             string sql = "select * from Paper where PaperState=" + b;
             return DBHelp.GetDataSet(sql);
         }
    }
}
