﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;

public partial class Admin_admin_FillBlankAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            User user = (User)Session["user"];
            if (user != null)
            {
                InitDDLData();          //初始化考试科目下拉列表框   
                if (Request["SingleProblemID"] != null)
                {
                    InitData();
                }
            }
            else
            {
                Response.Redirect("~/Login.aspx");//转向考试界面
            }
           

        }
    }
    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        ddlCourse.DataSource = ds;
        ddlCourse.DataTextField = "CourseName";
        ddlCourse.DataValueField = "CourseID";
        ddlCourse.DataBind();
    }


    //初始化数据
    protected void InitData()
    {
        int FillBlankProblemID = int.Parse(Request["FillBlankProblemID"].ToString());  //取出传递过来的试题编号
        FillBlankProblem fillPro = FillBlankProblemManager.GetFillBlankproblemById(FillBlankProblemID);//返回填空题对象
        
        if (fillPro != null)
        {
            ddlCourse.SelectedItem.Text = fillPro.FCourse.CName.ToString();
            txtFrontTitle.Text = fillPro.FfrontTitle;
            txtBackTitle.Text = fillPro.FBackTitle;
            txtAnswer.Text = fillPro.Fanswer;
        }
        else
        {
            lblMessage.Text = "加载数据出错!";
        }

    }
    //保存和修改事件
    protected void Button1_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            FillBlankProblem fillPro = new FillBlankProblem();
            fillPro.FCourse = CourseManager.GetCourseByString(ddlCourse.SelectedItem.Text.Trim());
            fillPro.FfrontTitle = this.txtFrontTitle.Text;
            fillPro.FBackTitle = this.txtBackTitle.Text;
            fillPro.Fanswer = this.txtAnswer.Text;
            if (Request["FillBlankProblemID"] != null)
            {
                fillPro.FillBlankProblemID = int.Parse(Request["FillBlankProblemID"].ToString());//取出试题主键
                
                if (FillBlankProblemManager.UpdateFillBlankProblem(fillPro))
                {
                    lblMessage.Text = "成功修改该单选题！";
                }
                else
                {
                    lblMessage.Text = "修改该单选题失败！";
                }
            }
            else
            {

                if (FillBlankProblemManager.AddFillBlankProblem(fillPro))
                {
                    lblMessage.Text = "成功添加该单选题！";
                }
                else
                {
                    lblMessage.Text = "添加该单选题失败！";
                }
            }

        }
    }
}
