﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;

public partial class Admin_admin_JianDaAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            User user = (User)Session["user"];
            if (user != null)
            {
                InitDDLData();          //初始化考试科目下拉列表框   
                if (Request["JiandaID"] != null)
                {

                    InitData();
                }
            }
            else
            {
                Response.Redirect("~/Login.aspx");//转向考试界面
            }

        }
    }
    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        ddlCourse.DataSource = ds;
        ddlCourse.DataTextField = "CourseName";
        ddlCourse.DataValueField = "CourseID";
        ddlCourse.DataBind();
    }
    //初始化数据
    protected void InitData()
    {
        int jdProblemID = int.Parse(Request["JiandaID"].ToString());  //取出传递过来的试题编号
        Jianda jdPro = JiandaManager.GetJiandaproblemById(jdProblemID); //返回填空题对象

        if (jdPro != null)
        {
            ddlCourse.SelectedItem.Text = jdPro.JCourse.CName.ToString();
            txtTitle.Text = jdPro.JTitle;
            txtAnswer.Text = jdPro.Janswer;
            
        }
        else
        {
            lblMessage.Text = "加载数据出错!";
        }

    }
    //保存和修改事件
    protected void Button1_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            Jianda jdPro = new Jianda();
            jdPro.JCourse = CourseManager.GetCourseByString(ddlCourse.SelectedItem.Text.Trim());
            jdPro.JTitle = this.txtTitle.Text;
            jdPro.Janswer = this.txtAnswer.Text;
            if (Request["JiandaID"] != null)
            {
                jdPro.JiandaID = int.Parse(Request["JiandaID"].ToString());//取出试题主键
                if (JiandaManager.UpdateJiandaProblem(jdPro))
                {
                    lblMessage.Text = "成功修改该单选题！";
                }
                else
                {
                    lblMessage.Text = "修改该单选题失败！";
                }
            }
            else
            {
                if(JiandaManager.AddJiandaProblem(jdPro))
                {
                    lblMessage.Text = "成功添加该单选题！";
                }
                else
                {
                     lblMessage.Text = "添加该单选题失败！";
                }
            }
        }
    }
}
