﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;

public partial class Admin_admin_JudgeAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            User user = (User)Session["user"];
            if (user != null)
            {
                InitDDLData();          //初始化考试科目下拉列表框   
                if (Request["JudgeProblemID"] != null)
                {
                    InitData();
                }
            }
            else
            {
                Response.Redirect("~/Login.aspx");//转向考试界面
            }

        }
    }
    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        DllCourse.DataSource = ds;
        DllCourse.DataTextField = "CourseName";
        DllCourse.DataValueField = "CourseID";
        DllCourse.DataBind();
    }

    //初始化数据
    protected void InitData()
    {
        int JudgeProblemID = int.Parse(Request["JudgeProblemID"].ToString());  //取出传递过来的试题编号
        JudgeProblem judPro = JudgeProblemManager.GetJudgeproblemById(JudgeProblemID);//返回单选题对象
        if (judPro != null)
        {
            DllCourse.SelectedItem.Text = judPro.JCourse.CName.ToString();
            txtTitle.Text = judPro.JTitle;
            RadioButtonList1.SelectedValue = judPro.JAnswer.ToString();

        }
        else
        {
            this.Label1.Text = "加载数据出错!";
        }

    }



    //添加和修改事件
    protected void Button1_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            JudgeProblem judPro = new JudgeProblem();
            judPro.JCourse = CourseManager.GetCourseByString(DllCourse.SelectedItem.Text.Trim());
            judPro.JTitle = this.txtTitle.Text;
            judPro.JAnswer=bool.Parse(RadioButtonList1.SelectedValue);

            if (Request["JudgeProblemID"] != null)
            {
                judPro.JudgeProblemID = int.Parse(Request["JudgeProblemID"].ToString());
                if (JudgeProblemManager.UpdateJudgeProblem(judPro))
                {
                    this.Label1.Text = "成功修改该判断题！";
                }
                else
                {
                    this.Label1.Text = "成功修改该判断题！";
                }
            }
            else
            {
                if (JudgeProblemManager.AddJudgeProblem(judPro))
                {
                    this.Label1.Text = "成功添加该判断题！";
                }
                else
                {
                    this.Label1.Text = "添加该判断题失败！";
                }
            } 

        }
       
    }
}
