﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamBLL.Auto_Generated_Code;
using ExamModel.Auto_Generated_Code;

public partial class Admin_admin_MultiSelectAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            User user = (User)Session["user"];
            if (user != null)
            {
                InitDDLData();          //初始化考试科目下拉列表框      
                if (Request["MultiProblemID"] != null)
                {
                    InitData();
                }
            }
            else
            {
                Response.Redirect("~/Login.aspx");//转向考试界面
            }

        }
    }
    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        DllCourse.DataSource = ds;
        DllCourse.DataTextField = "CourseName";
        DllCourse.DataValueField = "CourseID";
        DllCourse.DataBind();
    }
    //初始化数据
    protected void InitData()
    {
        int MultiProblemID = int.Parse(Request["MultiProblemID"].ToString());  //取出传递过来的试题编号
        MultiProblem multiPro = MultiProblemManager.GetMultiproblemById(MultiProblemID);//返回多选题对象
        if (multiPro != null)
        {
            DllCourse.SelectedItem.Text = multiPro.MCourse.CName.ToString();
            txtTitle.Text = multiPro.MTitle;
            txtAnswerA.Text = multiPro.ManswerA;
            txtAnswerB.Text = multiPro.ManswerB;
            txtAnswerC.Text = multiPro.ManswerC;
            txtAnswerD.Text = multiPro.ManswerD;
            string answer = multiPro.Manswer;
            for (int i = 0; i < answer.Length; i++)
            {
                string item = answer[i].ToString();
                for (int j = 0; j < cblAnswer.Items.Count; j++)
                {
                    if (item == cblAnswer.Items[i].Text)
                    {
                        cblAnswer.Items[i].Selected = true;
                    }
                }
            }

        }
        else
        {
            lblMessage.Text = "加载数据出错!";
        }

    }

    //添加或修改事件
    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            MultiProblem multPro = new MultiProblem();
            multPro.MCourse = CourseManager.GetCourseByString(DllCourse.SelectedItem.Text.Trim());
            multPro.MTitle = this.txtTitle.Text;
            multPro.ManswerA = this.txtAnswerA.Text;
            multPro.ManswerB = this.txtAnswerB.Text;
            multPro.ManswerC = this.txtAnswerC.Text;
            multPro.ManswerD = this.txtAnswerD.Text;
            string answer="";
            for (int i = 0; i < cblAnswer.Items.Count; i++)
            {
                if (cblAnswer.Items[i].Selected)
                {
                    answer += cblAnswer.Items[i].Text;
                }
            }
            multPro.Manswer = answer;

            if (Request["MultiProblemID"] != null)
            {
                multPro.MultiProblemID = int.Parse(Request["MultiProblemID"].ToString());//取出多选题试题主键
                if (MultiProblemManager.UpdateMultiProblem(multPro))
                {
                    lblMessage.Text = "成功修改该单选题！";
                }
                else
                {
                    lblMessage.Text = "修改该单选题失败！";
                }
            }
            else
            {
                if(MultiProblemManager.AddMultiProblem(multPro))
                {
                    lblMessage.Text = "成功添加该单选题！";
                }
                else
                {
                     lblMessage.Text = "添加该单选题失败！";
                }
            }

        }
    }
}
