﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamBLL.Auto_Generated_Code;
using ExamModel.Auto_Generated_Code;

public partial class Admin_admin_MultiSelectLists : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            User user = (User)Session["user"];
            if (user != null)
            {
                InitDDLData(); //初始化考试科目下拉列表框          

            }
            else
            {
                Response.Redirect("~/Login.aspx");//转向考试界面
            }        

        }
    }

    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        ddlCourse.DataSource = ds;
        ddlCourse.DataTextField = "CourseName";
        ddlCourse.DataValueField = "CourseID";
        ddlCourse.DataBind();
        GridViewBind();
    }
    ////显示选择科目的多选题
    protected void ddlCourse_SelectedIndexChanged(object sender, EventArgs e)
    {
        GridViewBind();//为GridView绑定数据
    }
    //GridView控件绑定数据事件
    protected void GridViewBind()
    {
        Course course = CourseManager.GetCourseByString(this.ddlCourse.SelectedItem.Text.Trim());
        DataSet ds = MultiProblemManager.GetMultiproByCoursename(course);
        GridView1.DataSource = ds.Tables[0].DefaultView;
        GridView1.DataBind();     //绑定数据
    }

    //触发删除事件
    protected void GridView1_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        int MultiProID = int.Parse(GridView1.DataKeys[e.RowIndex].Values[0].ToString());
        if (MultiProblemManager.DeleteMultiById(MultiProID))
        {
            Response.Write("<script language=javascript>alert('成功删除试题！')</script>");
        }
        else
        {
            Response.Write("<script language=javascript>alert('删除试题失败！')</script>");
        }
        GridView1.EditIndex = -1;
        GridViewBind();   //重新绑定数据
    }

    //删除多条记录
    protected void btnDel_Click(object sender, EventArgs e)
    {
        foreach (GridViewRow dr in GridView1.Rows)//对GridView中的每一行进行判断
        {
            if (((CheckBox)dr.FindControl("xuanze")).Checked)
            {
                int multiProId = int.Parse(((Label)dr.FindControl("Label2")).Text);
                MultiProblemManager.DeleteMultiById(multiProId);
            }
        }
        GridViewBind();   //重新绑定数据
    }
}
