﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamBLL.Auto_Generated_Code;
using ExamModel.Auto_Generated_Code;

public partial class Admin_admin_SingleSelectAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitDDLData();          //初始化考试科目下拉列表框   
            if (Request["SingleProblemID"] != null)
            {
                InitData();
            }
            
        }
    }
    //初始化考试科目
    protected void InitDDLData()
    {
        DataSet ds = CourseManager.QueryCourse();
        DllCourse.DataSource = ds;
        DllCourse.DataTextField = "CourseName";
        DllCourse.DataValueField = "CourseID";
        DllCourse.DataBind();
    }
    //初始化数据
    protected void InitData()
    {
        int SingleProblemID = int.Parse(Request["SingleProblemID"].ToString());  //取出传递过来的试题编号
        SingleProblem singPro = SingleProblemManager.GetSingleproblemById(SingleProblemID); //返回单选题对象
        if (singPro != null)
        {
            DllCourse.SelectedItem.Text = singPro.SCourse.CName.ToString();
            txtTitle.Text = singPro.STitle;
            txtAnswerA.Text = singPro.SanswerA;
            txtAnswerB.Text = singPro.SanswerB;
            txtAnswerC.Text = singPro.SanswerC;
            txtAnswerD.Text = singPro.SanswerD;
            DllAnswer.SelectedItem.Text = singPro.Sanswer;

        }
        else
        {
            lblMessage.Text = "加载数据出错!";
        }  
 
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            SingleProblem singPro = new SingleProblem();
            singPro.SCourse = CourseManager.GetCourseByString(DllCourse.SelectedItem.Text.Trim());
            singPro.STitle = this.txtTitle.Text;
            singPro.SanswerA = this.txtAnswerA.Text;
            singPro.SanswerB = this.txtAnswerB.Text;
            singPro.SanswerC = this.txtAnswerC.Text;
            singPro.SanswerD = this.txtAnswerD.Text;
            singPro.Sanswer = DllAnswer.SelectedItem.Text;
           
            
            if (Request["SingleProblemID"] != null)
            {
                singPro.SsingleProblemID = int.Parse(Request["SingleProblemID"].ToString());//取出试题主键
                if (SingleProblemManager.UpdateSingleProblem(singPro))
                {
                    lblMessage.Text = "成功修改该单选题！";
                }
                else
                {
                    lblMessage.Text = "修改该单选题失败！";
                }
            }
            else
            {

                if (SingleProblemManager.AddSingleProblem(singPro))
                {
                    lblMessage.Text = "成功添加该单选题！";
                }
                else
                {
                    lblMessage.Text = "添加该单选题失败！";
                }
            }

        }
       
        



    }
}
