﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;


public partial class Admin_admin_UserAdd : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitDDLData();
            InitDllRole();
            if (Request["ID"] != null)
            {
                InitData();　　　　　
            }
        }
    }
   
    //初始化系
    protected void InitDDLData()
    {
            
        DataSet ds = DepartmentManager.QueryDepartment();       //查询系信息
        dllDepartment.DataSource = ds;
        dllDepartment.DataTextField = "DepartmentName";
        dllDepartment.DataValueField = "DepartmentID";
        dllDepartment.DataBind();
    }
    //初始化角色
    protected void InitDllRole()
    {
        DataSet ds = RoleManager.QueryRole();
        dllRole.DataSource = ds;
        dllRole.DataTextField = "RoleName";
        dllRole.DataValueField = "RoleID";
        dllRole.DataBind();
    }

    //初始化数据
    protected void InitData()
    {
        int UserID = int.Parse(Request["ID"].ToString());  //取出传递过来的试题编号
        User user = UserManager.GetUserById(UserID);//返回用户对象
        if (user != null)
        {
            this.txtUid.Text = user.UID.ToString();
            this.txtPassword.Text = user.UPassWord;
            this.dllDepartment.SelectedIndex = user.UDepartment.DepartmentID-1;
            this.txtName.Text = user.UserName;
            this.raSex.SelectedValue = user.USex.ToString();
            this.txtAddress.Text = user.UAddress;
            this.txtPhone.Text = user.UPhone;
            this.txtEmail.Text = user.UEmail;
            this.dllRole.SelectedIndex = user.URole.RoleID-1;
        }

    }


    //注册用户事件
    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (Page.IsValid)
        {
            int DepartmentID = this.dllDepartment.SelectedIndex + 1;
            User user = new User();
            user.UID = this.txtUid.Text;
            user.UPassWord = this.txtPassword.Text;
            user.UDepartment = DepartmentManager.GetDepartmentById(DepartmentID);
            user.UserName = this.txtName.Text;
            user.USex = bool.Parse(this.raSex.SelectedValue);
            user.UAddress = this.txtAddress.Text;
            user.UPhone = this.txtPhone.Text;
            user.UEmail = this.txtEmail.Text;
            user.URole = RoleManager.GetRoleById(dllRole.SelectedIndex + 1);
            if (Request["ID"] != null)
            {
                user.ID = int.Parse(Request["ID"]);
                
                if (UserManager.UpdateUser(user))
                {
                    lblMessage.Text = "成功修改该单选题！";
                }
                else
                {
                    lblMessage.Text = "修改该单选题失败！";
                }
            }
            else
            {

                if (UserManager.Register(user))
                {
                    lblMessage.Text = "成功添加该单选题！";
                }
                else
                {
                    lblMessage.Text = "添加该单选题失败！";
                }
            }

        }








    }
}
