﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;

public partial class Login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InitData();//初始化科目列表框
            InitRole();//初始化角色
        }
    }
    //初始化考试科目下拉列表框
    protected void InitData()
    {
        Paper paper = new Paper();              //创建Paper对象
        DataSet ds = PaperManager.GetUsePaper(true); //查询所有可用试卷
            
        if (ds.Tables[0].Rows.Count >= 1)
        {
            ddlPaper.DataSource = ds;           //指名考试科目列表框数据源
            ddlPaper.DataTextField = "PaperName";   //DataTextField显示Name字段值
            ddlPaper.DataValueField = "PaperID";    //DataValueField显示ID字段值
            ddlPaper.DataBind();                //绑定数据
        }
        else
        {
            ddlPaper.Enabled = false;
            btnLogin.Enabled = false;
            lblMessage.Text = "没有试卷！";
        }
    }
    //初始化角色
    protected void InitRole()
    {
        DataSet ds = RoleManager.QueryRole();
        dllRole.DataSource = ds;
        dllRole.DataTextField = "RoleName";
        dllRole.DataValueField = "RoleID";
        dllRole.DataBind();
    }
    //登陆事件
    protected void btnLogin_Click(object sender, EventArgs e)
    {
        User user;
        int roleid=this.dllRole.SelectedIndex+1;
        int count=UserManager.Login(this.txtUserID.Text, this.txtPwd.Text,roleid, out user);
        //0表用户为空
        //1表成功
        //2该用户没有该权限
        //3密码不正确

        if (count == 0)
        {
            Response.Write("<script>alert('该考生不存在')</script>");
        }
        else if (count == 1)
        {
           // Paper paper = PaperManager.GetPaperByName(this.ddlPaper.SelectedItem.Text);
            Score score= ScoreManager.GetScoreByuid(txtUserID.Text);
            if (score != null)
            {
                Response.Write("<script>alert('该试卷用户已经参加考试')</script>");
            }
            else
            {
                Paper paper = PaperManager.GetPaperByName(this.ddlPaper.SelectedItem.Text);
                //Session["UserID"] = user.UID;
                Session["user"] = user;
                Session["PaperID"] = paper.PaperId;
                Session["PaperName"] = paper.PaperName;
                Response.Redirect("TestOnLine/Test.aspx");//转向考试界面
            }
        }
        else if (count == 5)
        {
            Session["user"] = user;
            Response.Redirect("Admin/Admin_CourseAdd.aspx");
        }
        else if (count == 2)
        {
            Response.Write("<script>alert('无权查看')</script>");
        }
        else if (count == 3)//密码错误，给出提示
        {
            Response.Write("<script>alert('用户名或密码不正确，请重新填写')</script>");
        }
    }
    protected void btnCanel_Click(object sender, EventArgs e)
    {
        Response.Redirect("~/UserRegister.aspx");
    }
}
