﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ExamModel.Auto_Generated_Code;
using ExamBLL.Auto_Generated_Code;

public partial class UserRegister : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
           
                snCode.Create();
                InitDDLData();
                InitDllRole();
           
        }
    }
    //初始化系
    protected void InitDDLData()
    {

        DataSet ds = DepartmentManager.QueryDepartment();       //查询系信息
        dllDepartment.DataSource = ds;
        dllDepartment.DataTextField = "DepartmentName";
        dllDepartment.DataValueField = "DepartmentID";
        dllDepartment.DataBind();
    }
    //初始化角色
    protected void InitDllRole()
    {
        DataSet ds = RoleManager.QueryRole();
        dllRole.DataSource = ds;
        dllRole.DataTextField = "RoleName";
        dllRole.DataValueField = "RoleID";
        dllRole.DataBind();
    }
    //注册用户事件
    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (!CeckCode())
        {
            this.lblMessage.Text = "<script>alert('验证码错误！')</script>";
            return;
        }
        int DepartmentID = this.dllDepartment.SelectedIndex + 1;
        User user = new User();
        user.UID = this.txtUid.Text;
        user.UPassWord = this.txtPassword.Text;
        user.UDepartment = DepartmentManager.GetDepartmentById(DepartmentID);
        user.UserName = this.txtName.Text;
        user.USex = bool.Parse(this.raSex.SelectedValue);
        user.UAddress = this.txtAddress.Text;
        user.UPhone = this.txtPhone.Text;
        user.UEmail = this.txtEmail.Text;
        user.URole = RoleManager.GetRoleById(this.dllRole.SelectedIndex + 1);
        if (!UserManager.Register(user))
        {
            this.lblMessage.Text = "<script>alert('用户名已使用！请重新选择！')</script>";
        }
        else
        {
            this.lblMessage.Text = "<script>alert('注册成功！')";
        }
    }
    //检查验证码
    protected bool CeckCode()
    {
        if (snCode.CheckSN(txtYz.Text.Trim()))
        {
            return true;
        }
        else
        {
            snCode.Create();
            return false;
        }
    }
    protected void btnCanel_Click(object sender, EventArgs e)
    {
        Response.Redirect("~/Login.aspx");
    }
}
